package ovh.herisson.Clyde.Tables.ScientificPublications;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;
import ovh.herisson.Clyde.Tables.User;
import java.util.Date;
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
public class Article {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    private String title;

    @ManyToOne(fetch = FetchType.EAGER)
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name ="Users")
    private User author;

    //todo change user to Researcher
    @CreationTimestamp
    @Column(nullable = false)
    private Date releaseDate;

    private PublishType publishType;

    private String pdfLocation;

    private String bibTexLocation;

    private String language;

    private Access access;

    private String domain;

    private String summary;

    private int views;
}

